// Code generated by ent, DO NOT EDIT.

package actions

import (
	"entgo.io/ent/dialect/sql"
	"github.com/FrankenBotDev/FrankenAPI/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// Refid applies equality check predicate on the "refid" field. It's identical to RefidEQ.
func Refid(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldRefid), v))
	})
}

// Commiter applies equality check predicate on the "commiter" field. It's identical to CommiterEQ.
func Commiter(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCommiter), v))
	})
}

// Serverid applies equality check predicate on the "serverid" field. It's identical to ServeridEQ.
func Serverid(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldServerid), v))
	})
}

// Target applies equality check predicate on the "target" field. It's identical to TargetEQ.
func Target(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTarget), v))
	})
}

// Type applies equality check predicate on the "type" field. It's identical to TypeEQ.
func Type(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldType), v))
	})
}

// Duration applies equality check predicate on the "duration" field. It's identical to DurationEQ.
func Duration(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDuration), v))
	})
}

// Reason applies equality check predicate on the "reason" field. It's identical to ReasonEQ.
func Reason(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldReason), v))
	})
}

// Temp applies equality check predicate on the "temp" field. It's identical to TempEQ.
func Temp(v bool) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTemp), v))
	})
}

// RefidEQ applies the EQ predicate on the "refid" field.
func RefidEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldRefid), v))
	})
}

// RefidNEQ applies the NEQ predicate on the "refid" field.
func RefidNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldRefid), v))
	})
}

// RefidIn applies the In predicate on the "refid" field.
func RefidIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldRefid), v...))
	})
}

// RefidNotIn applies the NotIn predicate on the "refid" field.
func RefidNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldRefid), v...))
	})
}

// RefidGT applies the GT predicate on the "refid" field.
func RefidGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldRefid), v))
	})
}

// RefidGTE applies the GTE predicate on the "refid" field.
func RefidGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldRefid), v))
	})
}

// RefidLT applies the LT predicate on the "refid" field.
func RefidLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldRefid), v))
	})
}

// RefidLTE applies the LTE predicate on the "refid" field.
func RefidLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldRefid), v))
	})
}

// RefidContains applies the Contains predicate on the "refid" field.
func RefidContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldRefid), v))
	})
}

// RefidHasPrefix applies the HasPrefix predicate on the "refid" field.
func RefidHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldRefid), v))
	})
}

// RefidHasSuffix applies the HasSuffix predicate on the "refid" field.
func RefidHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldRefid), v))
	})
}

// RefidEqualFold applies the EqualFold predicate on the "refid" field.
func RefidEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldRefid), v))
	})
}

// RefidContainsFold applies the ContainsFold predicate on the "refid" field.
func RefidContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldRefid), v))
	})
}

// CommiterEQ applies the EQ predicate on the "commiter" field.
func CommiterEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCommiter), v))
	})
}

// CommiterNEQ applies the NEQ predicate on the "commiter" field.
func CommiterNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldCommiter), v))
	})
}

// CommiterIn applies the In predicate on the "commiter" field.
func CommiterIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldCommiter), v...))
	})
}

// CommiterNotIn applies the NotIn predicate on the "commiter" field.
func CommiterNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldCommiter), v...))
	})
}

// CommiterGT applies the GT predicate on the "commiter" field.
func CommiterGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldCommiter), v))
	})
}

// CommiterGTE applies the GTE predicate on the "commiter" field.
func CommiterGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldCommiter), v))
	})
}

// CommiterLT applies the LT predicate on the "commiter" field.
func CommiterLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldCommiter), v))
	})
}

// CommiterLTE applies the LTE predicate on the "commiter" field.
func CommiterLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldCommiter), v))
	})
}

// CommiterContains applies the Contains predicate on the "commiter" field.
func CommiterContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldCommiter), v))
	})
}

// CommiterHasPrefix applies the HasPrefix predicate on the "commiter" field.
func CommiterHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldCommiter), v))
	})
}

// CommiterHasSuffix applies the HasSuffix predicate on the "commiter" field.
func CommiterHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldCommiter), v))
	})
}

// CommiterEqualFold applies the EqualFold predicate on the "commiter" field.
func CommiterEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldCommiter), v))
	})
}

// CommiterContainsFold applies the ContainsFold predicate on the "commiter" field.
func CommiterContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldCommiter), v))
	})
}

// ServeridEQ applies the EQ predicate on the "serverid" field.
func ServeridEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldServerid), v))
	})
}

// ServeridNEQ applies the NEQ predicate on the "serverid" field.
func ServeridNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldServerid), v))
	})
}

// ServeridIn applies the In predicate on the "serverid" field.
func ServeridIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldServerid), v...))
	})
}

// ServeridNotIn applies the NotIn predicate on the "serverid" field.
func ServeridNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldServerid), v...))
	})
}

// ServeridGT applies the GT predicate on the "serverid" field.
func ServeridGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldServerid), v))
	})
}

// ServeridGTE applies the GTE predicate on the "serverid" field.
func ServeridGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldServerid), v))
	})
}

// ServeridLT applies the LT predicate on the "serverid" field.
func ServeridLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldServerid), v))
	})
}

// ServeridLTE applies the LTE predicate on the "serverid" field.
func ServeridLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldServerid), v))
	})
}

// ServeridContains applies the Contains predicate on the "serverid" field.
func ServeridContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldServerid), v))
	})
}

// ServeridHasPrefix applies the HasPrefix predicate on the "serverid" field.
func ServeridHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldServerid), v))
	})
}

// ServeridHasSuffix applies the HasSuffix predicate on the "serverid" field.
func ServeridHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldServerid), v))
	})
}

// ServeridEqualFold applies the EqualFold predicate on the "serverid" field.
func ServeridEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldServerid), v))
	})
}

// ServeridContainsFold applies the ContainsFold predicate on the "serverid" field.
func ServeridContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldServerid), v))
	})
}

// TargetEQ applies the EQ predicate on the "target" field.
func TargetEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTarget), v))
	})
}

// TargetNEQ applies the NEQ predicate on the "target" field.
func TargetNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldTarget), v))
	})
}

// TargetIn applies the In predicate on the "target" field.
func TargetIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldTarget), v...))
	})
}

// TargetNotIn applies the NotIn predicate on the "target" field.
func TargetNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldTarget), v...))
	})
}

// TargetGT applies the GT predicate on the "target" field.
func TargetGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldTarget), v))
	})
}

// TargetGTE applies the GTE predicate on the "target" field.
func TargetGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldTarget), v))
	})
}

// TargetLT applies the LT predicate on the "target" field.
func TargetLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldTarget), v))
	})
}

// TargetLTE applies the LTE predicate on the "target" field.
func TargetLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldTarget), v))
	})
}

// TargetContains applies the Contains predicate on the "target" field.
func TargetContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldTarget), v))
	})
}

// TargetHasPrefix applies the HasPrefix predicate on the "target" field.
func TargetHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldTarget), v))
	})
}

// TargetHasSuffix applies the HasSuffix predicate on the "target" field.
func TargetHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldTarget), v))
	})
}

// TargetEqualFold applies the EqualFold predicate on the "target" field.
func TargetEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldTarget), v))
	})
}

// TargetContainsFold applies the ContainsFold predicate on the "target" field.
func TargetContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldTarget), v))
	})
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldType), v))
	})
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldType), v))
	})
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldType), v...))
	})
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldType), v...))
	})
}

// TypeGT applies the GT predicate on the "type" field.
func TypeGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldType), v))
	})
}

// TypeGTE applies the GTE predicate on the "type" field.
func TypeGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldType), v))
	})
}

// TypeLT applies the LT predicate on the "type" field.
func TypeLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldType), v))
	})
}

// TypeLTE applies the LTE predicate on the "type" field.
func TypeLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldType), v))
	})
}

// TypeContains applies the Contains predicate on the "type" field.
func TypeContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldType), v))
	})
}

// TypeHasPrefix applies the HasPrefix predicate on the "type" field.
func TypeHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldType), v))
	})
}

// TypeHasSuffix applies the HasSuffix predicate on the "type" field.
func TypeHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldType), v))
	})
}

// TypeEqualFold applies the EqualFold predicate on the "type" field.
func TypeEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldType), v))
	})
}

// TypeContainsFold applies the ContainsFold predicate on the "type" field.
func TypeContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldType), v))
	})
}

// DurationEQ applies the EQ predicate on the "duration" field.
func DurationEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDuration), v))
	})
}

// DurationNEQ applies the NEQ predicate on the "duration" field.
func DurationNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldDuration), v))
	})
}

// DurationIn applies the In predicate on the "duration" field.
func DurationIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldDuration), v...))
	})
}

// DurationNotIn applies the NotIn predicate on the "duration" field.
func DurationNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldDuration), v...))
	})
}

// DurationGT applies the GT predicate on the "duration" field.
func DurationGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldDuration), v))
	})
}

// DurationGTE applies the GTE predicate on the "duration" field.
func DurationGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldDuration), v))
	})
}

// DurationLT applies the LT predicate on the "duration" field.
func DurationLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldDuration), v))
	})
}

// DurationLTE applies the LTE predicate on the "duration" field.
func DurationLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldDuration), v))
	})
}

// DurationContains applies the Contains predicate on the "duration" field.
func DurationContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldDuration), v))
	})
}

// DurationHasPrefix applies the HasPrefix predicate on the "duration" field.
func DurationHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldDuration), v))
	})
}

// DurationHasSuffix applies the HasSuffix predicate on the "duration" field.
func DurationHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldDuration), v))
	})
}

// DurationEqualFold applies the EqualFold predicate on the "duration" field.
func DurationEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldDuration), v))
	})
}

// DurationContainsFold applies the ContainsFold predicate on the "duration" field.
func DurationContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldDuration), v))
	})
}

// ReasonEQ applies the EQ predicate on the "reason" field.
func ReasonEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldReason), v))
	})
}

// ReasonNEQ applies the NEQ predicate on the "reason" field.
func ReasonNEQ(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldReason), v))
	})
}

// ReasonIn applies the In predicate on the "reason" field.
func ReasonIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldReason), v...))
	})
}

// ReasonNotIn applies the NotIn predicate on the "reason" field.
func ReasonNotIn(vs ...string) predicate.Actions {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Actions(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldReason), v...))
	})
}

// ReasonGT applies the GT predicate on the "reason" field.
func ReasonGT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldReason), v))
	})
}

// ReasonGTE applies the GTE predicate on the "reason" field.
func ReasonGTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldReason), v))
	})
}

// ReasonLT applies the LT predicate on the "reason" field.
func ReasonLT(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldReason), v))
	})
}

// ReasonLTE applies the LTE predicate on the "reason" field.
func ReasonLTE(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldReason), v))
	})
}

// ReasonContains applies the Contains predicate on the "reason" field.
func ReasonContains(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldReason), v))
	})
}

// ReasonHasPrefix applies the HasPrefix predicate on the "reason" field.
func ReasonHasPrefix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldReason), v))
	})
}

// ReasonHasSuffix applies the HasSuffix predicate on the "reason" field.
func ReasonHasSuffix(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldReason), v))
	})
}

// ReasonEqualFold applies the EqualFold predicate on the "reason" field.
func ReasonEqualFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldReason), v))
	})
}

// ReasonContainsFold applies the ContainsFold predicate on the "reason" field.
func ReasonContainsFold(v string) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldReason), v))
	})
}

// TempEQ applies the EQ predicate on the "temp" field.
func TempEQ(v bool) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTemp), v))
	})
}

// TempNEQ applies the NEQ predicate on the "temp" field.
func TempNEQ(v bool) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldTemp), v))
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Actions) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Actions) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Actions) predicate.Actions {
	return predicate.Actions(func(s *sql.Selector) {
		p(s.Not())
	})
}
