// Code generated by ent, DO NOT EDIT.

package logging

import (
	"entgo.io/ent/dialect/sql"
	"github.com/FrankenBotDev/FrankenAPI/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// Serverid applies equality check predicate on the "serverid" field. It's identical to ServeridEQ.
func Serverid(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldServerid), v))
	})
}

// Type applies equality check predicate on the "type" field. It's identical to TypeEQ.
func Type(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldType), v))
	})
}

// Commiter applies equality check predicate on the "commiter" field. It's identical to CommiterEQ.
func Commiter(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCommiter), v))
	})
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDescription), v))
	})
}

// ServeridEQ applies the EQ predicate on the "serverid" field.
func ServeridEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldServerid), v))
	})
}

// ServeridNEQ applies the NEQ predicate on the "serverid" field.
func ServeridNEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldServerid), v))
	})
}

// ServeridIn applies the In predicate on the "serverid" field.
func ServeridIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldServerid), v...))
	})
}

// ServeridNotIn applies the NotIn predicate on the "serverid" field.
func ServeridNotIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldServerid), v...))
	})
}

// ServeridGT applies the GT predicate on the "serverid" field.
func ServeridGT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldServerid), v))
	})
}

// ServeridGTE applies the GTE predicate on the "serverid" field.
func ServeridGTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldServerid), v))
	})
}

// ServeridLT applies the LT predicate on the "serverid" field.
func ServeridLT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldServerid), v))
	})
}

// ServeridLTE applies the LTE predicate on the "serverid" field.
func ServeridLTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldServerid), v))
	})
}

// ServeridContains applies the Contains predicate on the "serverid" field.
func ServeridContains(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldServerid), v))
	})
}

// ServeridHasPrefix applies the HasPrefix predicate on the "serverid" field.
func ServeridHasPrefix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldServerid), v))
	})
}

// ServeridHasSuffix applies the HasSuffix predicate on the "serverid" field.
func ServeridHasSuffix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldServerid), v))
	})
}

// ServeridEqualFold applies the EqualFold predicate on the "serverid" field.
func ServeridEqualFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldServerid), v))
	})
}

// ServeridContainsFold applies the ContainsFold predicate on the "serverid" field.
func ServeridContainsFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldServerid), v))
	})
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldType), v))
	})
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldType), v))
	})
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldType), v...))
	})
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldType), v...))
	})
}

// TypeGT applies the GT predicate on the "type" field.
func TypeGT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldType), v))
	})
}

// TypeGTE applies the GTE predicate on the "type" field.
func TypeGTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldType), v))
	})
}

// TypeLT applies the LT predicate on the "type" field.
func TypeLT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldType), v))
	})
}

// TypeLTE applies the LTE predicate on the "type" field.
func TypeLTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldType), v))
	})
}

// TypeContains applies the Contains predicate on the "type" field.
func TypeContains(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldType), v))
	})
}

// TypeHasPrefix applies the HasPrefix predicate on the "type" field.
func TypeHasPrefix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldType), v))
	})
}

// TypeHasSuffix applies the HasSuffix predicate on the "type" field.
func TypeHasSuffix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldType), v))
	})
}

// TypeEqualFold applies the EqualFold predicate on the "type" field.
func TypeEqualFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldType), v))
	})
}

// TypeContainsFold applies the ContainsFold predicate on the "type" field.
func TypeContainsFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldType), v))
	})
}

// CommiterEQ applies the EQ predicate on the "commiter" field.
func CommiterEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCommiter), v))
	})
}

// CommiterNEQ applies the NEQ predicate on the "commiter" field.
func CommiterNEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldCommiter), v))
	})
}

// CommiterIn applies the In predicate on the "commiter" field.
func CommiterIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldCommiter), v...))
	})
}

// CommiterNotIn applies the NotIn predicate on the "commiter" field.
func CommiterNotIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldCommiter), v...))
	})
}

// CommiterGT applies the GT predicate on the "commiter" field.
func CommiterGT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldCommiter), v))
	})
}

// CommiterGTE applies the GTE predicate on the "commiter" field.
func CommiterGTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldCommiter), v))
	})
}

// CommiterLT applies the LT predicate on the "commiter" field.
func CommiterLT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldCommiter), v))
	})
}

// CommiterLTE applies the LTE predicate on the "commiter" field.
func CommiterLTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldCommiter), v))
	})
}

// CommiterContains applies the Contains predicate on the "commiter" field.
func CommiterContains(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldCommiter), v))
	})
}

// CommiterHasPrefix applies the HasPrefix predicate on the "commiter" field.
func CommiterHasPrefix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldCommiter), v))
	})
}

// CommiterHasSuffix applies the HasSuffix predicate on the "commiter" field.
func CommiterHasSuffix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldCommiter), v))
	})
}

// CommiterEqualFold applies the EqualFold predicate on the "commiter" field.
func CommiterEqualFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldCommiter), v))
	})
}

// CommiterContainsFold applies the ContainsFold predicate on the "commiter" field.
func CommiterContainsFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldCommiter), v))
	})
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDescription), v))
	})
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldDescription), v))
	})
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldDescription), v...))
	})
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.Logging {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Logging(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldDescription), v...))
	})
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldDescription), v))
	})
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldDescription), v))
	})
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldDescription), v))
	})
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldDescription), v))
	})
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldDescription), v))
	})
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldDescription), v))
	})
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldDescription), v))
	})
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldDescription), v))
	})
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldDescription), v))
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Logging) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Logging) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Logging) predicate.Logging {
	return predicate.Logging(func(s *sql.Selector) {
		p(s.Not())
	})
}
