package schema

import (
	"entgo.io/ent"
	"entgo.io/ent/schema/field"
)

// Actions holds the schema definition for the Actions entity.
type Actions struct {
	ent.Schema
}

// Fields of the Actions.
func (Actions) Fields() []ent.Field {
	return []ent.Field{
		field.Int("id").Unique(),
		field.String("refid"),
		field.String("commiter"),
		field.String("serverid"),
		field.String("target"),
		field.String("type"),
		field.String("duration"),
		field.String("reason"),
		field.Bool("temp").Default(false),
	}
}

// Edges of the Actions.
func (Actions) Edges() []ent.Edge {
	return nil
}
