package schema

import (
	"entgo.io/ent"
	"entgo.io/ent/schema/field"
)

// Settings holds the schema definition for the Settings entity.
type Settings struct {
	ent.Schema
}

// Fields of the Settings.
func (Settings) Fields() []ent.Field {
	return []ent.Field{
		field.Int("id").Unique(),
		field.String("serverid"),
		field.String("servername"),
		field.String("ownerid"),
		field.String("permtoken"),
		field.String("apitoken"),
		field.String("statspagemode"),
		field.String("loggerchannel"),
		field.String("spamchannel"),
		field.String("greeterchannel"),
		field.String("greetermode"),
		field.String("announcechannel"),
		field.Bool("logger").Default(false),
		field.Bool("spamprotection").Default(false),
		field.Bool("linkprotection").Default(false),
		field.Bool("wordfilter").Default(false),
		field.Bool("greetings").Default(false),
		field.Bool("apitoggle").Default(false),
		field.Bool("moderation").Default(false),
		field.Bool("automatedmoderation").Default(false),
		field.Bool("twitchannounce").Default(false),
		field.Bool("twitterannounce").Default(false),
		field.Bool("music").Default(false),
		field.Bool("statspage").Default(false),
		field.Bool("statsprivate").Default(false),
		field.Bool("stats").Default(false),
	}
}

// Edges of the Settings.
func (Settings) Edges() []ent.Edge {
	return nil
}
