package schema

import (
	"entgo.io/ent"
	"entgo.io/ent/schema/field"
)

// Support holds the schema definition for the Support entity.
type Support struct {
	ent.Schema
}

// Fields of the Support.
func (Support) Fields() []ent.Field {
	return []ent.Field{
		field.Int("id").Unique(),
		field.String("refid"),
		field.String("serverid"),
		field.String("creator"),
		field.String("status"),
		field.String("title"),
		field.String("description"),
	}
}

// Edges of the Support.
func (Support) Edges() []ent.Edge {
	return nil
}
