package schema

import (
	"entgo.io/ent"
	"entgo.io/ent/dialect/entsql"
	"entgo.io/ent/schema/field"
)

// SupportResponse holds the schema definition for the SupportResponse entity.
type SupportResponse struct {
	ent.Schema
}

// Fields of the SupportResponse.
func (SupportResponse) Fields() []ent.Field {
	return []ent.Field{
		field.Int("id").Unique(),
		field.String("refid"),
		field.String("writer"),
		field.String("message"),
		field.String("type"),
		field.String("rtcchannel"),
		field.Bool("isread"),
		field.Time("created").Annotations(&entsql.Annotation{
			Default: "CURRENT_TIMESTAMP",
		}),
	}
}

// Edges of the SupportResponse.
func (SupportResponse) Edges() []ent.Edge {
	return nil
}
