// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"

	"entgo.io/ent/dialect/sql"
	"github.com/FrankenBotDev/FrankenAPI/ent/servers"
)

// Servers is the model entity for the Servers schema.
type Servers struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// Userid holds the value of the "userid" field.
	Userid string `json:"userid,omitempty"`
	// Serverid holds the value of the "serverid" field.
	Serverid string `json:"serverid,omitempty"`
	// IsOwner holds the value of the "isOwner" field.
	IsOwner bool `json:"isOwner,omitempty"`
	// Permission holds the value of the "permission" field.
	Permission string `json:"permission,omitempty"`
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Servers) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case servers.FieldIsOwner:
			values[i] = new(sql.NullBool)
		case servers.FieldID:
			values[i] = new(sql.NullInt64)
		case servers.FieldUserid, servers.FieldServerid, servers.FieldPermission:
			values[i] = new(sql.NullString)
		default:
			return nil, fmt.Errorf("unexpected column %q for type Servers", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Servers fields.
func (s *Servers) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case servers.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			s.ID = int(value.Int64)
		case servers.FieldUserid:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field userid", values[i])
			} else if value.Valid {
				s.Userid = value.String
			}
		case servers.FieldServerid:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field serverid", values[i])
			} else if value.Valid {
				s.Serverid = value.String
			}
		case servers.FieldIsOwner:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field isOwner", values[i])
			} else if value.Valid {
				s.IsOwner = value.Bool
			}
		case servers.FieldPermission:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field permission", values[i])
			} else if value.Valid {
				s.Permission = value.String
			}
		}
	}
	return nil
}

// Update returns a builder for updating this Servers.
// Note that you need to call Servers.Unwrap() before calling this method if this Servers
// was returned from a transaction, and the transaction was committed or rolled back.
func (s *Servers) Update() *ServersUpdateOne {
	return (&ServersClient{config: s.config}).UpdateOne(s)
}

// Unwrap unwraps the Servers entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (s *Servers) Unwrap() *Servers {
	_tx, ok := s.config.driver.(*txDriver)
	if !ok {
		panic("ent: Servers is not a transactional entity")
	}
	s.config.driver = _tx.drv
	return s
}

// String implements the fmt.Stringer.
func (s *Servers) String() string {
	var builder strings.Builder
	builder.WriteString("Servers(")
	builder.WriteString(fmt.Sprintf("id=%v, ", s.ID))
	builder.WriteString("userid=")
	builder.WriteString(s.Userid)
	builder.WriteString(", ")
	builder.WriteString("serverid=")
	builder.WriteString(s.Serverid)
	builder.WriteString(", ")
	builder.WriteString("isOwner=")
	builder.WriteString(fmt.Sprintf("%v", s.IsOwner))
	builder.WriteString(", ")
	builder.WriteString("permission=")
	builder.WriteString(s.Permission)
	builder.WriteByte(')')
	return builder.String()
}

// ServersSlice is a parsable slice of Servers.
type ServersSlice []*Servers

func (s ServersSlice) config(cfg config) {
	for _i := range s {
		s[_i].config = cfg
	}
}
