// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/FrankenBotDev/FrankenAPI/ent/servers"
)

// ServersCreate is the builder for creating a Servers entity.
type ServersCreate struct {
	config
	mutation *ServersMutation
	hooks    []Hook
}

// SetUserid sets the "userid" field.
func (sc *ServersCreate) SetUserid(s string) *ServersCreate {
	sc.mutation.SetUserid(s)
	return sc
}

// SetServerid sets the "serverid" field.
func (sc *ServersCreate) SetServerid(s string) *ServersCreate {
	sc.mutation.SetServerid(s)
	return sc
}

// SetIsOwner sets the "isOwner" field.
func (sc *ServersCreate) SetIsOwner(b bool) *ServersCreate {
	sc.mutation.SetIsOwner(b)
	return sc
}

// SetPermission sets the "permission" field.
func (sc *ServersCreate) SetPermission(s string) *ServersCreate {
	sc.mutation.SetPermission(s)
	return sc
}

// SetID sets the "id" field.
func (sc *ServersCreate) SetID(i int) *ServersCreate {
	sc.mutation.SetID(i)
	return sc
}

// Mutation returns the ServersMutation object of the builder.
func (sc *ServersCreate) Mutation() *ServersMutation {
	return sc.mutation
}

// Save creates the Servers in the database.
func (sc *ServersCreate) Save(ctx context.Context) (*Servers, error) {
	var (
		err  error
		node *Servers
	)
	if len(sc.hooks) == 0 {
		if err = sc.check(); err != nil {
			return nil, err
		}
		node, err = sc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ServersMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = sc.check(); err != nil {
				return nil, err
			}
			sc.mutation = mutation
			if node, err = sc.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(sc.hooks) - 1; i >= 0; i-- {
			if sc.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = sc.hooks[i](mut)
		}
		v, err := mut.Mutate(ctx, sc.mutation)
		if err != nil {
			return nil, err
		}
		nv, ok := v.(*Servers)
		if !ok {
			return nil, fmt.Errorf("unexpected node type %T returned from ServersMutation", v)
		}
		node = nv
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (sc *ServersCreate) SaveX(ctx context.Context) *Servers {
	v, err := sc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (sc *ServersCreate) Exec(ctx context.Context) error {
	_, err := sc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (sc *ServersCreate) ExecX(ctx context.Context) {
	if err := sc.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (sc *ServersCreate) check() error {
	if _, ok := sc.mutation.Userid(); !ok {
		return &ValidationError{Name: "userid", err: errors.New(`ent: missing required field "Servers.userid"`)}
	}
	if _, ok := sc.mutation.Serverid(); !ok {
		return &ValidationError{Name: "serverid", err: errors.New(`ent: missing required field "Servers.serverid"`)}
	}
	if _, ok := sc.mutation.IsOwner(); !ok {
		return &ValidationError{Name: "isOwner", err: errors.New(`ent: missing required field "Servers.isOwner"`)}
	}
	if _, ok := sc.mutation.Permission(); !ok {
		return &ValidationError{Name: "permission", err: errors.New(`ent: missing required field "Servers.permission"`)}
	}
	return nil
}

func (sc *ServersCreate) sqlSave(ctx context.Context) (*Servers, error) {
	_node, _spec := sc.createSpec()
	if err := sqlgraph.CreateNode(ctx, sc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = int(id)
	}
	return _node, nil
}

func (sc *ServersCreate) createSpec() (*Servers, *sqlgraph.CreateSpec) {
	var (
		_node = &Servers{config: sc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: servers.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: servers.FieldID,
			},
		}
	)
	if id, ok := sc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := sc.mutation.Userid(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: servers.FieldUserid,
		})
		_node.Userid = value
	}
	if value, ok := sc.mutation.Serverid(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: servers.FieldServerid,
		})
		_node.Serverid = value
	}
	if value, ok := sc.mutation.IsOwner(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeBool,
			Value:  value,
			Column: servers.FieldIsOwner,
		})
		_node.IsOwner = value
	}
	if value, ok := sc.mutation.Permission(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: servers.FieldPermission,
		})
		_node.Permission = value
	}
	return _node, _spec
}

// ServersCreateBulk is the builder for creating many Servers entities in bulk.
type ServersCreateBulk struct {
	config
	builders []*ServersCreate
}

// Save creates the Servers entities in the database.
func (scb *ServersCreateBulk) Save(ctx context.Context) ([]*Servers, error) {
	specs := make([]*sqlgraph.CreateSpec, len(scb.builders))
	nodes := make([]*Servers, len(scb.builders))
	mutators := make([]Mutator, len(scb.builders))
	for i := range scb.builders {
		func(i int, root context.Context) {
			builder := scb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ServersMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, scb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, scb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, scb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (scb *ServersCreateBulk) SaveX(ctx context.Context) []*Servers {
	v, err := scb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (scb *ServersCreateBulk) Exec(ctx context.Context) error {
	_, err := scb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (scb *ServersCreateBulk) ExecX(ctx context.Context) {
	if err := scb.Exec(ctx); err != nil {
		panic(err)
	}
}
