// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"

	"entgo.io/ent/dialect/sql"
	"github.com/FrankenBotDev/FrankenAPI/ent/settings"
)

// Settings is the model entity for the Settings schema.
type Settings struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// Serverid holds the value of the "serverid" field.
	Serverid string `json:"serverid,omitempty"`
	// Servername holds the value of the "servername" field.
	Servername string `json:"servername,omitempty"`
	// Ownerid holds the value of the "ownerid" field.
	Ownerid string `json:"ownerid,omitempty"`
	// Permtoken holds the value of the "permtoken" field.
	Permtoken string `json:"permtoken,omitempty"`
	// Apitoken holds the value of the "apitoken" field.
	Apitoken string `json:"apitoken,omitempty"`
	// Statspagemode holds the value of the "statspagemode" field.
	Statspagemode string `json:"statspagemode,omitempty"`
	// Loggerchannel holds the value of the "loggerchannel" field.
	Loggerchannel string `json:"loggerchannel,omitempty"`
	// Spamchannel holds the value of the "spamchannel" field.
	Spamchannel string `json:"spamchannel,omitempty"`
	// Greeterchannel holds the value of the "greeterchannel" field.
	Greeterchannel string `json:"greeterchannel,omitempty"`
	// Greetermode holds the value of the "greetermode" field.
	Greetermode string `json:"greetermode,omitempty"`
	// Announcechannel holds the value of the "announcechannel" field.
	Announcechannel string `json:"announcechannel,omitempty"`
	// Logger holds the value of the "logger" field.
	Logger bool `json:"logger,omitempty"`
	// Spamprotection holds the value of the "spamprotection" field.
	Spamprotection bool `json:"spamprotection,omitempty"`
	// Linkprotection holds the value of the "linkprotection" field.
	Linkprotection bool `json:"linkprotection,omitempty"`
	// Wordfilter holds the value of the "wordfilter" field.
	Wordfilter bool `json:"wordfilter,omitempty"`
	// Greetings holds the value of the "greetings" field.
	Greetings bool `json:"greetings,omitempty"`
	// Apitoggle holds the value of the "apitoggle" field.
	Apitoggle bool `json:"apitoggle,omitempty"`
	// Moderation holds the value of the "moderation" field.
	Moderation bool `json:"moderation,omitempty"`
	// Automatedmoderation holds the value of the "automatedmoderation" field.
	Automatedmoderation bool `json:"automatedmoderation,omitempty"`
	// Twitchannounce holds the value of the "twitchannounce" field.
	Twitchannounce bool `json:"twitchannounce,omitempty"`
	// Twitterannounce holds the value of the "twitterannounce" field.
	Twitterannounce bool `json:"twitterannounce,omitempty"`
	// Music holds the value of the "music" field.
	Music bool `json:"music,omitempty"`
	// Statspage holds the value of the "statspage" field.
	Statspage bool `json:"statspage,omitempty"`
	// Statsprivate holds the value of the "statsprivate" field.
	Statsprivate bool `json:"statsprivate,omitempty"`
	// Stats holds the value of the "stats" field.
	Stats bool `json:"stats,omitempty"`
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Settings) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case settings.FieldLogger, settings.FieldSpamprotection, settings.FieldLinkprotection, settings.FieldWordfilter, settings.FieldGreetings, settings.FieldApitoggle, settings.FieldModeration, settings.FieldAutomatedmoderation, settings.FieldTwitchannounce, settings.FieldTwitterannounce, settings.FieldMusic, settings.FieldStatspage, settings.FieldStatsprivate, settings.FieldStats:
			values[i] = new(sql.NullBool)
		case settings.FieldID:
			values[i] = new(sql.NullInt64)
		case settings.FieldServerid, settings.FieldServername, settings.FieldOwnerid, settings.FieldPermtoken, settings.FieldApitoken, settings.FieldStatspagemode, settings.FieldLoggerchannel, settings.FieldSpamchannel, settings.FieldGreeterchannel, settings.FieldGreetermode, settings.FieldAnnouncechannel:
			values[i] = new(sql.NullString)
		default:
			return nil, fmt.Errorf("unexpected column %q for type Settings", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Settings fields.
func (s *Settings) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case settings.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			s.ID = int(value.Int64)
		case settings.FieldServerid:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field serverid", values[i])
			} else if value.Valid {
				s.Serverid = value.String
			}
		case settings.FieldServername:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field servername", values[i])
			} else if value.Valid {
				s.Servername = value.String
			}
		case settings.FieldOwnerid:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field ownerid", values[i])
			} else if value.Valid {
				s.Ownerid = value.String
			}
		case settings.FieldPermtoken:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field permtoken", values[i])
			} else if value.Valid {
				s.Permtoken = value.String
			}
		case settings.FieldApitoken:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field apitoken", values[i])
			} else if value.Valid {
				s.Apitoken = value.String
			}
		case settings.FieldStatspagemode:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field statspagemode", values[i])
			} else if value.Valid {
				s.Statspagemode = value.String
			}
		case settings.FieldLoggerchannel:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field loggerchannel", values[i])
			} else if value.Valid {
				s.Loggerchannel = value.String
			}
		case settings.FieldSpamchannel:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field spamchannel", values[i])
			} else if value.Valid {
				s.Spamchannel = value.String
			}
		case settings.FieldGreeterchannel:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field greeterchannel", values[i])
			} else if value.Valid {
				s.Greeterchannel = value.String
			}
		case settings.FieldGreetermode:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field greetermode", values[i])
			} else if value.Valid {
				s.Greetermode = value.String
			}
		case settings.FieldAnnouncechannel:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field announcechannel", values[i])
			} else if value.Valid {
				s.Announcechannel = value.String
			}
		case settings.FieldLogger:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field logger", values[i])
			} else if value.Valid {
				s.Logger = value.Bool
			}
		case settings.FieldSpamprotection:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field spamprotection", values[i])
			} else if value.Valid {
				s.Spamprotection = value.Bool
			}
		case settings.FieldLinkprotection:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field linkprotection", values[i])
			} else if value.Valid {
				s.Linkprotection = value.Bool
			}
		case settings.FieldWordfilter:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field wordfilter", values[i])
			} else if value.Valid {
				s.Wordfilter = value.Bool
			}
		case settings.FieldGreetings:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field greetings", values[i])
			} else if value.Valid {
				s.Greetings = value.Bool
			}
		case settings.FieldApitoggle:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field apitoggle", values[i])
			} else if value.Valid {
				s.Apitoggle = value.Bool
			}
		case settings.FieldModeration:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field moderation", values[i])
			} else if value.Valid {
				s.Moderation = value.Bool
			}
		case settings.FieldAutomatedmoderation:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field automatedmoderation", values[i])
			} else if value.Valid {
				s.Automatedmoderation = value.Bool
			}
		case settings.FieldTwitchannounce:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field twitchannounce", values[i])
			} else if value.Valid {
				s.Twitchannounce = value.Bool
			}
		case settings.FieldTwitterannounce:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field twitterannounce", values[i])
			} else if value.Valid {
				s.Twitterannounce = value.Bool
			}
		case settings.FieldMusic:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field music", values[i])
			} else if value.Valid {
				s.Music = value.Bool
			}
		case settings.FieldStatspage:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field statspage", values[i])
			} else if value.Valid {
				s.Statspage = value.Bool
			}
		case settings.FieldStatsprivate:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field statsprivate", values[i])
			} else if value.Valid {
				s.Statsprivate = value.Bool
			}
		case settings.FieldStats:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field stats", values[i])
			} else if value.Valid {
				s.Stats = value.Bool
			}
		}
	}
	return nil
}

// Update returns a builder for updating this Settings.
// Note that you need to call Settings.Unwrap() before calling this method if this Settings
// was returned from a transaction, and the transaction was committed or rolled back.
func (s *Settings) Update() *SettingsUpdateOne {
	return (&SettingsClient{config: s.config}).UpdateOne(s)
}

// Unwrap unwraps the Settings entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (s *Settings) Unwrap() *Settings {
	_tx, ok := s.config.driver.(*txDriver)
	if !ok {
		panic("ent: Settings is not a transactional entity")
	}
	s.config.driver = _tx.drv
	return s
}

// String implements the fmt.Stringer.
func (s *Settings) String() string {
	var builder strings.Builder
	builder.WriteString("Settings(")
	builder.WriteString(fmt.Sprintf("id=%v, ", s.ID))
	builder.WriteString("serverid=")
	builder.WriteString(s.Serverid)
	builder.WriteString(", ")
	builder.WriteString("servername=")
	builder.WriteString(s.Servername)
	builder.WriteString(", ")
	builder.WriteString("ownerid=")
	builder.WriteString(s.Ownerid)
	builder.WriteString(", ")
	builder.WriteString("permtoken=")
	builder.WriteString(s.Permtoken)
	builder.WriteString(", ")
	builder.WriteString("apitoken=")
	builder.WriteString(s.Apitoken)
	builder.WriteString(", ")
	builder.WriteString("statspagemode=")
	builder.WriteString(s.Statspagemode)
	builder.WriteString(", ")
	builder.WriteString("loggerchannel=")
	builder.WriteString(s.Loggerchannel)
	builder.WriteString(", ")
	builder.WriteString("spamchannel=")
	builder.WriteString(s.Spamchannel)
	builder.WriteString(", ")
	builder.WriteString("greeterchannel=")
	builder.WriteString(s.Greeterchannel)
	builder.WriteString(", ")
	builder.WriteString("greetermode=")
	builder.WriteString(s.Greetermode)
	builder.WriteString(", ")
	builder.WriteString("announcechannel=")
	builder.WriteString(s.Announcechannel)
	builder.WriteString(", ")
	builder.WriteString("logger=")
	builder.WriteString(fmt.Sprintf("%v", s.Logger))
	builder.WriteString(", ")
	builder.WriteString("spamprotection=")
	builder.WriteString(fmt.Sprintf("%v", s.Spamprotection))
	builder.WriteString(", ")
	builder.WriteString("linkprotection=")
	builder.WriteString(fmt.Sprintf("%v", s.Linkprotection))
	builder.WriteString(", ")
	builder.WriteString("wordfilter=")
	builder.WriteString(fmt.Sprintf("%v", s.Wordfilter))
	builder.WriteString(", ")
	builder.WriteString("greetings=")
	builder.WriteString(fmt.Sprintf("%v", s.Greetings))
	builder.WriteString(", ")
	builder.WriteString("apitoggle=")
	builder.WriteString(fmt.Sprintf("%v", s.Apitoggle))
	builder.WriteString(", ")
	builder.WriteString("moderation=")
	builder.WriteString(fmt.Sprintf("%v", s.Moderation))
	builder.WriteString(", ")
	builder.WriteString("automatedmoderation=")
	builder.WriteString(fmt.Sprintf("%v", s.Automatedmoderation))
	builder.WriteString(", ")
	builder.WriteString("twitchannounce=")
	builder.WriteString(fmt.Sprintf("%v", s.Twitchannounce))
	builder.WriteString(", ")
	builder.WriteString("twitterannounce=")
	builder.WriteString(fmt.Sprintf("%v", s.Twitterannounce))
	builder.WriteString(", ")
	builder.WriteString("music=")
	builder.WriteString(fmt.Sprintf("%v", s.Music))
	builder.WriteString(", ")
	builder.WriteString("statspage=")
	builder.WriteString(fmt.Sprintf("%v", s.Statspage))
	builder.WriteString(", ")
	builder.WriteString("statsprivate=")
	builder.WriteString(fmt.Sprintf("%v", s.Statsprivate))
	builder.WriteString(", ")
	builder.WriteString("stats=")
	builder.WriteString(fmt.Sprintf("%v", s.Stats))
	builder.WriteByte(')')
	return builder.String()
}

// SettingsSlice is a parsable slice of Settings.
type SettingsSlice []*Settings

func (s SettingsSlice) config(cfg config) {
	for _i := range s {
		s[_i].config = cfg
	}
}
