// Code generated by ent, DO NOT EDIT.

package support

import (
	"entgo.io/ent/dialect/sql"
	"github.com/FrankenBotDev/FrankenAPI/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// Refid applies equality check predicate on the "refid" field. It's identical to RefidEQ.
func Refid(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldRefid), v))
	})
}

// Serverid applies equality check predicate on the "serverid" field. It's identical to ServeridEQ.
func Serverid(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldServerid), v))
	})
}

// Creator applies equality check predicate on the "creator" field. It's identical to CreatorEQ.
func Creator(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCreator), v))
	})
}

// Status applies equality check predicate on the "status" field. It's identical to StatusEQ.
func Status(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldStatus), v))
	})
}

// Title applies equality check predicate on the "title" field. It's identical to TitleEQ.
func Title(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTitle), v))
	})
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDescription), v))
	})
}

// RefidEQ applies the EQ predicate on the "refid" field.
func RefidEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldRefid), v))
	})
}

// RefidNEQ applies the NEQ predicate on the "refid" field.
func RefidNEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldRefid), v))
	})
}

// RefidIn applies the In predicate on the "refid" field.
func RefidIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldRefid), v...))
	})
}

// RefidNotIn applies the NotIn predicate on the "refid" field.
func RefidNotIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldRefid), v...))
	})
}

// RefidGT applies the GT predicate on the "refid" field.
func RefidGT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldRefid), v))
	})
}

// RefidGTE applies the GTE predicate on the "refid" field.
func RefidGTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldRefid), v))
	})
}

// RefidLT applies the LT predicate on the "refid" field.
func RefidLT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldRefid), v))
	})
}

// RefidLTE applies the LTE predicate on the "refid" field.
func RefidLTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldRefid), v))
	})
}

// RefidContains applies the Contains predicate on the "refid" field.
func RefidContains(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldRefid), v))
	})
}

// RefidHasPrefix applies the HasPrefix predicate on the "refid" field.
func RefidHasPrefix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldRefid), v))
	})
}

// RefidHasSuffix applies the HasSuffix predicate on the "refid" field.
func RefidHasSuffix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldRefid), v))
	})
}

// RefidEqualFold applies the EqualFold predicate on the "refid" field.
func RefidEqualFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldRefid), v))
	})
}

// RefidContainsFold applies the ContainsFold predicate on the "refid" field.
func RefidContainsFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldRefid), v))
	})
}

// ServeridEQ applies the EQ predicate on the "serverid" field.
func ServeridEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldServerid), v))
	})
}

// ServeridNEQ applies the NEQ predicate on the "serverid" field.
func ServeridNEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldServerid), v))
	})
}

// ServeridIn applies the In predicate on the "serverid" field.
func ServeridIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldServerid), v...))
	})
}

// ServeridNotIn applies the NotIn predicate on the "serverid" field.
func ServeridNotIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldServerid), v...))
	})
}

// ServeridGT applies the GT predicate on the "serverid" field.
func ServeridGT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldServerid), v))
	})
}

// ServeridGTE applies the GTE predicate on the "serverid" field.
func ServeridGTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldServerid), v))
	})
}

// ServeridLT applies the LT predicate on the "serverid" field.
func ServeridLT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldServerid), v))
	})
}

// ServeridLTE applies the LTE predicate on the "serverid" field.
func ServeridLTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldServerid), v))
	})
}

// ServeridContains applies the Contains predicate on the "serverid" field.
func ServeridContains(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldServerid), v))
	})
}

// ServeridHasPrefix applies the HasPrefix predicate on the "serverid" field.
func ServeridHasPrefix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldServerid), v))
	})
}

// ServeridHasSuffix applies the HasSuffix predicate on the "serverid" field.
func ServeridHasSuffix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldServerid), v))
	})
}

// ServeridEqualFold applies the EqualFold predicate on the "serverid" field.
func ServeridEqualFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldServerid), v))
	})
}

// ServeridContainsFold applies the ContainsFold predicate on the "serverid" field.
func ServeridContainsFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldServerid), v))
	})
}

// CreatorEQ applies the EQ predicate on the "creator" field.
func CreatorEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldCreator), v))
	})
}

// CreatorNEQ applies the NEQ predicate on the "creator" field.
func CreatorNEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldCreator), v))
	})
}

// CreatorIn applies the In predicate on the "creator" field.
func CreatorIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldCreator), v...))
	})
}

// CreatorNotIn applies the NotIn predicate on the "creator" field.
func CreatorNotIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldCreator), v...))
	})
}

// CreatorGT applies the GT predicate on the "creator" field.
func CreatorGT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldCreator), v))
	})
}

// CreatorGTE applies the GTE predicate on the "creator" field.
func CreatorGTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldCreator), v))
	})
}

// CreatorLT applies the LT predicate on the "creator" field.
func CreatorLT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldCreator), v))
	})
}

// CreatorLTE applies the LTE predicate on the "creator" field.
func CreatorLTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldCreator), v))
	})
}

// CreatorContains applies the Contains predicate on the "creator" field.
func CreatorContains(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldCreator), v))
	})
}

// CreatorHasPrefix applies the HasPrefix predicate on the "creator" field.
func CreatorHasPrefix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldCreator), v))
	})
}

// CreatorHasSuffix applies the HasSuffix predicate on the "creator" field.
func CreatorHasSuffix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldCreator), v))
	})
}

// CreatorEqualFold applies the EqualFold predicate on the "creator" field.
func CreatorEqualFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldCreator), v))
	})
}

// CreatorContainsFold applies the ContainsFold predicate on the "creator" field.
func CreatorContainsFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldCreator), v))
	})
}

// StatusEQ applies the EQ predicate on the "status" field.
func StatusEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldStatus), v))
	})
}

// StatusNEQ applies the NEQ predicate on the "status" field.
func StatusNEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldStatus), v))
	})
}

// StatusIn applies the In predicate on the "status" field.
func StatusIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldStatus), v...))
	})
}

// StatusNotIn applies the NotIn predicate on the "status" field.
func StatusNotIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldStatus), v...))
	})
}

// StatusGT applies the GT predicate on the "status" field.
func StatusGT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldStatus), v))
	})
}

// StatusGTE applies the GTE predicate on the "status" field.
func StatusGTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldStatus), v))
	})
}

// StatusLT applies the LT predicate on the "status" field.
func StatusLT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldStatus), v))
	})
}

// StatusLTE applies the LTE predicate on the "status" field.
func StatusLTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldStatus), v))
	})
}

// StatusContains applies the Contains predicate on the "status" field.
func StatusContains(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldStatus), v))
	})
}

// StatusHasPrefix applies the HasPrefix predicate on the "status" field.
func StatusHasPrefix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldStatus), v))
	})
}

// StatusHasSuffix applies the HasSuffix predicate on the "status" field.
func StatusHasSuffix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldStatus), v))
	})
}

// StatusEqualFold applies the EqualFold predicate on the "status" field.
func StatusEqualFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldStatus), v))
	})
}

// StatusContainsFold applies the ContainsFold predicate on the "status" field.
func StatusContainsFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldStatus), v))
	})
}

// TitleEQ applies the EQ predicate on the "title" field.
func TitleEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldTitle), v))
	})
}

// TitleNEQ applies the NEQ predicate on the "title" field.
func TitleNEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldTitle), v))
	})
}

// TitleIn applies the In predicate on the "title" field.
func TitleIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldTitle), v...))
	})
}

// TitleNotIn applies the NotIn predicate on the "title" field.
func TitleNotIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldTitle), v...))
	})
}

// TitleGT applies the GT predicate on the "title" field.
func TitleGT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldTitle), v))
	})
}

// TitleGTE applies the GTE predicate on the "title" field.
func TitleGTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldTitle), v))
	})
}

// TitleLT applies the LT predicate on the "title" field.
func TitleLT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldTitle), v))
	})
}

// TitleLTE applies the LTE predicate on the "title" field.
func TitleLTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldTitle), v))
	})
}

// TitleContains applies the Contains predicate on the "title" field.
func TitleContains(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldTitle), v))
	})
}

// TitleHasPrefix applies the HasPrefix predicate on the "title" field.
func TitleHasPrefix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldTitle), v))
	})
}

// TitleHasSuffix applies the HasSuffix predicate on the "title" field.
func TitleHasSuffix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldTitle), v))
	})
}

// TitleEqualFold applies the EqualFold predicate on the "title" field.
func TitleEqualFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldTitle), v))
	})
}

// TitleContainsFold applies the ContainsFold predicate on the "title" field.
func TitleContainsFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldTitle), v))
	})
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldDescription), v))
	})
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldDescription), v))
	})
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldDescription), v...))
	})
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.Support {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.Support(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldDescription), v...))
	})
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldDescription), v))
	})
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldDescription), v))
	})
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldDescription), v))
	})
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldDescription), v))
	})
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldDescription), v))
	})
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldDescription), v))
	})
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldDescription), v))
	})
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldDescription), v))
	})
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldDescription), v))
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Support) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Support) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Support) predicate.Support {
	return predicate.Support(func(s *sql.Selector) {
		p(s.Not())
	})
}
